"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rx_1 = require("@reactive-js/rx");
const disposable_1 = require("@reactive-js/disposable");
exports.fromEvent = (target, eventName, selector) => rx_1.createObservable(notify => {
    const disposable = disposable_1.createDisposable();
    const listener = (event) => {
        try {
            const result = selector(event);
            notify(result);
        }
        catch (cause) {
            disposable.dispose({ cause });
        }
    };
    target.addEventListener(eventName, listener, { passive: true });
    disposable.add(() => {
        target.removeEventListener(eventName, listener);
    });
    return disposable;
});
//# sourceMappingURL=event.js.map