import { createObservable } from "@reactive-js/rx";
import { createDisposable } from "@reactive-js/disposable";
export const fromEvent = (target, eventName, selector) => createObservable(notify => {
    const disposable = createDisposable();
    const listener = (event) => {
        try {
            const result = selector(event);
            notify(result);
        }
        catch (cause) {
            disposable.dispose({ cause });
        }
    };
    target.addEventListener(eventName, listener, { passive: true });
    disposable.add(() => {
        target.removeEventListener(eventName, listener);
    });
    return disposable;
});
//# sourceMappingURL=event.js.map